//
//  Controller.h
//  HatenaDiaryAssistance
//
//  Created by KOYAMA Yoshiaki on 07/05/01.
//  Copyright 2007 KOYAMA Yoshiaki. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface Controller : NSObject {
	IBOutlet id gTitle;
	IBOutlet id gUrl;

	IBOutlet id gLineButton;
	IBOutlet id gTitleButton;
	IBOutlet id gTitleEqualButton;
}

// Hatena
- (IBAction)titleCopyButton:(id)sender;
- (void)copyPasteboardString:(NSString *)string;

// Link
- (IBAction)getInfoSafari:(id)sender;
- (NSString *)getInfo:(NSString *)scriptFile;
- (IBAction)linkTitleCopyButton:(id)sender;
- (IBAction)linkUrlCopyButton:(id)sender;

// ToolTip
- (void)setToolTipButton;
- (IBAction)copyToolTip:(id)sender;

//	Nib
- (void)awakeFromNib;

// Window
- (BOOL)windowShouldClose:(id)sender;

@end
