//
//  Controller.m
//  HatenaDiaryAssistance
//
//  Created by KOYAMA Yoshiaki on 07/05/01.
//  Copyright 2007 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"


@implementation Controller

// Hatena

/*
	Nbv{[hɕRs[
*/
- (void)copyPasteboardString:(NSString *)string {
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	
	if (([string isEqualToString:@""] == YES) || (string == nil))
		return;

	// w
	array = [NSArray arrayWithObject:NSStringPboardType];

	[board declareTypes:array owner:nil];
	[board setString:string forType:NSStringPboardType];
}

/*
	{^̃^CgNbv{[hɃRs[
*/
- (IBAction)titleCopyButton:(id)sender {
	NSString *title;

	title = [sender title];

	// Nbv{[hɃRs[
	[self copyPasteboardString:title];
}

// Link

/*
	SafariAURLATitleo
*/
- (IBAction)getInfoSafari:(id)sender {
	NSString *value;

	value = [self getInfo:@"safari_name.applescript"];
	if ((value != NULL) && (value != nil))
		[gTitle setStringValue:value];

	value = [self getInfo:@"safari_url.applescript"];
	if ((value != NULL) && (value != nil))
		[gUrl setStringValue:value];

	[self setToolTipButton];
}

/*
	AbvXNvg̖߂lԂ
*/
- (NSString *)getInfo:(NSString *)scriptFile {
    NSString *path;
    NSURL *url;
    NSAppleScript *script;
    NSDictionary *errorInfo = nil;
	NSAppleEventDescriptor *aed;
	
	// XNvgt@C path 쐬 
    path = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:scriptFile];
    url = [NSURL fileURLWithPath:path];

    script = [[NSAppleScript alloc] initWithContentsOfURL:url error:&errorInfo];

    aed = [script executeAndReturnError:&errorInfo];
	[script release];

	return [aed stringValue];
}

/*
	Link Title Nbv{[hɃRs[
*/
- (IBAction)linkTitleCopyButton:(id)sender {
	NSString *title;

	title = [gTitle stringValue];

	// Nbv{[hɃRs[
	[self copyPasteboardString:title];
}

/*
	Link URL Nbv{[hɃRs[
*/
- (IBAction)linkUrlCopyButton:(id)sender {
	NSString *url;

	url = [gUrl stringValue];

	// Nbv{[hɃRs[
	[self copyPasteboardString:url];
}

// ToolTip

/*
	{^ ToolTip ݒ
*/
- (void)setToolTipButton {
	NSString *line;
	NSString *title;
	NSString *titleEqual;
	NSString *vTitle;
	NSString *vUrl;
		
	vTitle = [gTitle stringValue];
	vUrl = [gUrl stringValue];

	if (vTitle == nil)
		vTitle = @"";
	if (vUrl == nil)
		vUrl = @"";

	line = [NSString stringWithFormat:@"%@\n%@\n", vTitle, vUrl];
	title = [NSString stringWithFormat:@"[%@:title]\n", vUrl];
	titleEqual = [NSString stringWithFormat:@"[%@:title=%@]\n", vUrl, vTitle];

	if (line != nil)
		[gLineButton setToolTip:line];

	if (title != nil)
		[gTitleButton setToolTip:title];

	if (titleEqual != nil)
		[gTitleEqualButton setToolTip:titleEqual];
}

/*
	ToolTip Nbv{[hɃRs[
*/
- (IBAction)copyToolTip:(id)sender {

	// Nbv{[hɃRs[
	[self copyPasteboardString:[sender toolTip]];
}

//	Nib

/*
	NSUserDefaultsController
*/
- (void)awakeFromNib {
	NSUserDefaultsController *defaultsController;
	id values;
	id value;

	[gTitle setDelegate:self];
	[gUrl setDelegate:self];

	defaultsController = [NSUserDefaultsController sharedUserDefaultsController];	
	values = [defaultsController values];

	value = [values valueForKey:@"tabItem"];

	if (value != nil) {
		[values setValue:[NSNumber numberWithInt:0] forKey:@"tabItem"];
	}
}

// Window

/*
	EChEƂ̏
*/
- (BOOL)windowShouldClose:(id)sender {

	[NSApp terminate:self];
    return YES;
}

// delegate

/*
	eLXgtB[hύX
*/
- (void)controlTextDidChange:(NSNotification *)aNotification {

//- (void)textDidChange:(NSNotification *)aNotification 삵Ȃ̂ controlTextDidChange 𗘗p

	[self setToolTipButton];
}
@end
